//
// Example: automatic testing of Servlets.
//
// 1) Test this class using the "Class Testing UI".
//
// 2) Look at the test cases generated by Jtest. Notice the following:
//    2.1) Jtest generates test cases that cover 100% of the code.
//    2.2) The Outcomes contain the ServletResponse output.


package examples.apis.servlets;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class DivideServlet extends HttpServlet
{
    public void init ()
    {
        _log = new Vector ();
    }

    public void doGet (HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        response.setContentType ("text/html");

        PrintWriter out = response.getWriter();

        String snumerator   = request.getParameter ("numerator");
        String sdenominator = request.getParameter ("denominator");
        _log.addElement (snumerator + '/' + sdenominator);

        try {
            int numerator   = Integer.parseInt (snumerator);
            int denominator = Integer.parseInt (sdenominator);
            int result = numerator / denominator;
            out.println ("<HTML>");
            out.println ("<HEAD><TITLE>Divide</TITLE></HEAD>");
            out.println ("<BODY>");
            out.println ("<H1>Result is " + result + "</H1>");
            out.println ("</BODY>");
            out.println ("</HTML>");
        } catch (Exception e) {
            response.sendError (HttpServletResponse.SC_BAD_REQUEST
                , e.toString ()
            );
        }
    }

    private Vector _log;
}
