// Stack: a very simple Stack class.
//
// We will use this stack class to show how jtest! automatically finds
// errors using dynamic analysis.
//
// 1) First run jtest on this CORRECT class to have jtest automatically
//    generate a test-suite for this class.
//
// 2) Experiment introducing some of the BUGs suggested in the comments
//    and rerun jtest to see how the bug is found automatically.


package examples.dynamic;


public class Stack
{
    public Stack ()
    {
        //BUG: comment the next line to introduce a bug that is uncovered as
        // an uncaught RuntimeException and as an Regression Error
        _storage = new Object [10];
        _size = 0;
    }

    public void push (Object object)
    {
        if (_size >= _storage.length) {
            // expand '_storage'
            Object[] old_storage = _storage;
            _storage = new Object [_size + 1];
            System.arraycopy (old_storage, 0, _storage, 0, old_storage.length);
        }

	// Comment the CORRECT line and uncomment the INCORRECT line to 
	// introduce a bug that is uncovered as a Regression Error by jtest!.

        _storage [_size++] = object;  // CORRECT

	// INCORRECT: forgot to increase _size
        //_storage [_size] = object;
    }

    public Object pop ()
        throws java.util.EmptyStackException
    {
	// Comment the next two lines to introduce a bug
        //if (_size <= 0)
        //    throw new java.util.EmptyStackException ();  

	// Comment the CORRECT line and uncomment the INCORRECT line to 
	// introduce a bug that is uncovered as a Regression Error by jtest!.

        return _storage [--_size];  // CORRECT
	//INCORRECT: forgot to decrease _size and returning wrong element
        //return _storage [_size];  // CORRECT
    }

    public int size () {
        return _size;
    }
 
    private Object[] _storage;
    private int      _size;
}
