// This example shows how a user-defined input is
// defined for an argument taking an IO object (i.e.
// a DataInputStream).
//
// 1) Load the test "FileIO.ctp"
// 2) Look at the user defined inputs for method "method".
//    2.1) Push the "Class" button in the toolbar.
//    2.2) Open "Dynamic Analysis" -> "Test Case Generation"
//         -> "User Defined" -> "Method Inputs" -> "method"
//         -> "java.io.DataInputStream ARG1"
//
// Note that a DataInputStream has been defined for the
// argument to "method".
//
// 3) Run the test:
//    3.1) Push the "Start" button in the toolbar.
// 4) Look at the user defined test cases run:
//    4.1) Push the "View" button in the toolbar.
//    4.2) Open "User Defined Test Cases" -> method"
//         -> "Test Case 1".
//
// Here we see that the outcome from running the user defined
// test case is 7 (the file "FileIO.dat" contains the values
// 3 and 4).


package examples.dynamic.blackbox;

import java.io.*;

public class FileIO
{
    static int method (DataInputStream dis)
        throws IOException
    {
        return dis.readInt () + dis.readInt ();
    }
}
