// Queue.java class with lots of bugs introduced.


package examples.dynamic.blackbox;

public class Queue
{
    public Queue () {
        _first = null;
        _last  = null;
    }
    
    public void add (Object item) {
        QueueItem queue_item = new QueueItem (item);
        if (isEmpty ()) {
            _first = queue_item;
            _last  = queue_item;
        } else {
            // put item at the beginning instead of at the end 
            queue_item.setNext (_first);
            _first = queue_item;
        }
    } 

    public Object remove () {
        if (isEmpty ())
            return null;  // returns null instead of throwing the Exception

        // returns first, but doesn't remove it
        QueueItem first = _first;
        return first.getItem ();
    }

    public boolean isEmpty () {
        return _first != null;  // == changed to !=
    }

    public void removeAll () {
        // forgot to clear '_first'
        _last  = null;
    }

    public String toString () {
        StringBuffer buffer = new StringBuffer ("Queue[");
        for (QueueItem next = _first; next != null; next = next.getNext ()) {
            if (next != _first)
                buffer.append (",");
            buffer.append (next.getItem ().toString ());
        }
        buffer.append ("]");
        return buffer.toString ();
    }

    private QueueItem _first;
    private QueueItem _last;

    private class QueueItem {
        QueueItem (Object item) {
            _item = item;
        }
        Object getItem () {
            return _item;
        }
        QueueItem getNext () {
            return _next;
        }
        void setNext (QueueItem next) {
            _next = next;
        }
        private QueueItem _next;
        private Object    _item;
    }
}

class EmptyQueueException extends RuntimeException {}
