// This example shows how to set up some initialization code
// before a class is tested.
//
// If this class is tested, jtest finds a NullPointerException
// for the calling sequence: "TestMe.get (0);".
//
// The NullPointerException happens because the class "GlobalVector"
// has not been initialized. We can tell jtest to initialize that
// class before testing the class "TestMe".
//
// To see how is this done, Open the test "TestMe.ctp" located
// in this directory. This test specification specifies some
// initialization code that needs to be executed before the
// class is tested. To see the initialization code:
//
// 1) Push the "Class" button in the "Class Testing UI" toolbar.
// 2) Open "Dynamic Analysis" -> "Test Case Generation"
//    -> "Common".
// 3) Select the "Edit" popup menu for "Class Initialization" to
//    see or edit the class initialization code.


package examples.dynamic.common.ClassInit;

public class TestMe {
    public static String get (int index) {
        return GlobalVector.get (index);
    }
}
