// EXAMPLE: Inspector: example usage of jtestInspector.
//
// Jtest checks Object values by representing them using the "toString"
// method and some public instance methods chosen heuristically.
// If that default automatic representation is not enought, you can use
// a method called 'jtestInspector ()'. Jtest will use that method to
// represent the Object state.
//
// 1) Test this class using jtest:
//    1.1) Open the "Inspector.ctp" in this directory.
//    1.2) Push the "Start" button.
//
// 2) Look at the first test case generated for the method "make":
//    2.1) Push the "View" button.
//    2.2) Open "Automatic Test Cases" -> "make" -> "Test Case 1".
//
// In the "Outcomes" branch you can see that the Object return value
// "RETVAL" is represented using the "jtestInspector" methods.


package examples.dynamic.regression;

public class Inspector
{
    public static Inspector make (int type) {
        return new Inspector (type, "unknown");
    }

    private Inspector (int type, String name) {
        _type = type;
        _name = name;
    }

    private String jtestInspector () {
        return "[" + _name + "," + _type + "]";
    }

    private String _name;
    private int    _type;
}
