// EXAMPLE: how jtest! checks Object values
//
// Jtest checks Object values by representing them using the "toString"
// method and some public instance methods chosen heuristically.
//
// 1) Test this class using jtest:
//    1.1) Open the "ObjectValue.ctp" in this directory.
//    1.2) Push the "Start" button.
//
// 2) Look at the first test case generated for the method "make":
//    2.1) Push the "View" button.
//    2.2) Open "Automatic Test Cases" -> "make" -> "Test Case 1".
//
// In the "Outcomes" branch you can see that the Object return value
// "RETVAL" is represented using the "toString" and "getType" methods.
// Also notive that the type of the Object ("ObjectValue") is also 
// shown.
//
// Whenever this class is tested again, jtest will check if any of
// those outcomes changed have changed and if so it will report an error.


package examples.dynamic.regression;

public class ObjectValue
{
    public static ObjectValue make (int type) {
        return new ObjectValue (type, "unknown");
    }

    public String toString () {
        return _name + ": " + _type;
    }

    private ObjectValue (int type, String name) {
        _type = type;
        _name = name;
    }

    public int getType () {
        return _type;
    }

    private String _name;
    private int    _type;
}
