// Example: regression testing of the return value of array type
//
// This example shows how jtest keeps track of the outcomes
// for method return values of array type.
//
// The method 'get' returns a different type of array
// depending on the value of the input argument 'type'
//
// 1) Test this class with jtest.
//
// 2) View the automatically generated test cases:
//    2.1) Push the "View" button in the "Class Testing UI" toolbar.
//    2.2) Open "Automatic Test Cases" -> "get".
//    2.3) Open the "Test Case" nodes.
//
//    Notice that for the Object return value, jtest puts as one of
//    the outcomes "RETVAL = <non-null> (class-name)".
//
//    If the return value is null, jtest puts as one of the outcomes
//    "RETVAL = null".
//
//    NOTE: if the RETVAL Object is a String jtest just puts as outcome
//    the actual value of the String (i.e. "ABC").


package examples.dynamic.regression;

public class RetArray
{
    public static Object get (int type)
    {
        switch (type) {
        case 0: return new int[] {1, 10, 100, 1000, 10000, 100000};
        case 1: return new Character [] {
                      new Character ('a')
                    , new Character ('b')
                    , new Character ('c')
                    , new Character ('d')
                    , new Character ('e')
                    , new Character ('f')
                    , new Character ('g')
                };
        case 2: return new String[] {"ABC", "12", "some words", null, "####"};
        case 3: return new Object[] {};
        case 4: return new boolean [] {true, false, false};
        case 5: return new byte [] {1, 2, 3, 4, 5};
        default: return null;
        }
    }
}
