// Example: regression testing of the return value object type.
//
// This example shows how jtest keeps track of the type
// for method return values that are objects.
//
// The method 'get' returns a different type of object
// depending on the value of the input argument 'type'
//
// For object values, jtest checks as one of the outcomes
// the type of the object.
//
// 1) Test this class with jtest.
//
// 2) View the automatically generated test cases:
//    2.1) Push the "View" button in the "Class Testing UI" toolbar.
//    2.2) Open "Automatic Test Cases" -> "get".
//    2.3) Open the "Test Case" nodes.
//
//    Notice that for the Object return value, jtest puts as one of
//    the outcomes "RETVAL = <non-null> (class-name)".
//
//    If the return value is null, jtest puts as one of the outcomes
//    "RETVAL = null".
//
//    NOTE: if the RETVAL Object is a String jtest just puts as outcome
//    the actual value of the String (i.e. "ABC").


package examples.dynamic.regression;

import java.util.Vector;

public class RetObjType
{
    public static Object get (int type)
    {
        switch (type) {
        case 0: return new String ("ABC");
        case 1: return new Integer (1);
        case 2: return new Vector ();
        default: return null;
        }
    }
}
