// EXAMPLE: This: shows how jtest checks modifications to the this object
//
// Sometimes the only effect of invoking a method is that it modifies
// the "this" object on which it applies.
// Jtest automatically checks this by using the state of the "this" object
// as one of the outcomes.
//
// 1) Test this class using jtest:
//    1.1) Open the "This.ctp" in this directory.
//    1.2) Push the "Start" button.
//
// 2) Look at the test case generated for the method "increment":
//    2.1) Push the "View" button.
//    2.2) Open "Automatic Test Cases" -> "increment" -> "Test Case 1".
//
// Note that jtest puts the THIS Object in the list of Outcomes for any
// instance method.
//
// Jtest represents the THIS Object as it would represent any other Object,
// see: ObjectValue.java and Inspector.java.


package examples.dynamic.regression;

public class This
{
    public int increment () {
        _size++;
        return 3;
    }

    public int getSize () {
        return _size;
    }

    private int _size;
}
