//
// Simplest example of I/O white-box stubs
//
// This example shows how jtest does white-box testing of code using I/O.
// Using white-box stubs jtest generates return values for the I/O calls
// so that the code is tested and exceptions are generated.
//
// 1) Load the test "IO1.ctp".
//
// 2) Run the test by pushing the "Start" button in the "Class Testing UI".
//
// 3) Look at the "Uncaught Runtime Exception" found by jtest:
//    3.1) The error message says that an ArrayIndexOutOfBoundsException
//         will happen if the method 'readInt ()' returns the value 20.
//
// 4) Look at the test-cases generated:
//    4.1) Push the "View" button in the toolbar.
//


package examples.dynamic.stubs.auto;

import java.io.*;

public class IO1
{
    public int get (DataInputStream dis)
        throws IOException
    {
        int index = dis.readInt ();
        return _table [index];
    }

    private int [] _table = new int [20];
}
