//
// Example of SQL white-box stubs
//
// This example shows how jtest does white-box testing of code using SQL.
// Using white-box stubs jtest generates return values for the SQL calls
// so that the code is tested and exceptions are generated.
//
// 1) Test this class using the "Class Testing UI".
//
// 2) Look at the "Uncaught Runtime Exception" found by jtest:
//    2.1) The error message says that an ArrayIndexOutOfBoundsException
//         will happen if the method 'getInt (int)' returns the value 10.
//
// 3) Look at the test-cases generated:
//    3.1) Push the "View" button in the toolbar.
//


package examples.dynamic.stubs.auto;

import java.sql.*;

public class SQL 
{
    public int employeeCount (Connection connection) 
        throws SQLException 
    {
        Statement sqlStatement = connection.createStatement ();
        String sql = "select id from employee where first_name = \'Tom\'";
        ResultSet results = sqlStatement.executeQuery (sql);

        if (results.next ()) {
            int id = results.getInt (1);
            return _employee [id];
        }

        return -1;
    }
    private int [] _employee = new int [10];
}
