//
// Example: how to define stubs for constructors.
//
// See "ConstructorExample.ctp".
//
   
package examples.dynamic.stubs.userdef;

import java.io.*;
import java.lang.reflect.*;

public class ConstructorExample
{
    public static long getFileLength (String path)
    {
        File file = new File (path);
        return file.length ();
    }
}

class ConstructorExampleStubs extends jtest.Stubs
{
    public static Object stubs (Constructor ctor, Object _this, Object[] args)
    {
        String class_name = ctor.getDeclaringClass ().getName ();

        if (class_name.equals ("java.io.File")) {
            String path = (String) args [0];
            if (path.equals (null))
                throw new NullPointerException ();
            return VOID;
        }

        return NO_STUB_GENERATED;
    }

    public static Object stubs (Method method)
    {
        if (method.getName ().equals ("length"))
            return new Long (10000000000000L);

        return NO_STUB_GENERATED;
    } 
}
