//
// Example of user defined stubs for EJB.
//
// This class uses the Table bean interface. We are going to test this
// class using user defined test cases and stubs.
//
// Notice that even though an implementation of Table (TableBean) doesn't
// exists, we still can test classes using the Table bean interface thanks
// to the user defined stubs.
//
// The stubs for the external calls that TableClient done are defined in
// "TableClientStubs.java".
//
// Please do the following:
//
// 1) Load "TableClient.ctp" in the "Class Testing UI".
//
// 2) Push the "Class" button in the toolbar and see the parameters for
//    the test:
//    - One user input is defined in: "Dynamic Analysis" -> "Test Case 
//      Generation" -> "User Defined".
//    - The option of using user defined stubs for the user defined test
//      cases is selected.
//
// 3) Push "Start" in the toolbar to execute the user defined test case.
//
// 4) Notice the "Uncaught Runtime Exception" found and the input that 
//    generated it. Notice that the user defined stubs defined in 
//    "TableClientStubs.java" have been used for the "Test Case Input".
//


package examples.dynamic.stubs.userdef.EJB;

import javax.naming.*;
import java.rmi.RemoteException;

public class TableClient
{
    public static void main (String[] args)
        throws NamingException, RemoteException
    {
        Context context = new InitialContext ();
        TableHome home = (TableHome) context.lookup ("Table");

        Table table = home.create ();

        System.out.println ("array1 = " + new int [table.getSize (1)]);
        System.out.println ("array2 = " + new int [table.getSize (2)]);
    } 
}
