//
// Simple example of User Defined Stubs.
//
//
// Stub Classes:
// -------------
//
// To test this class using the User Defined Stubs defined in
// "FileExampleStubs.java" do the following:
//
// 1) Start Jtest, open the "Class Testing UI" and close the "Project
//    Testing UI" if open.
//
// 2) Press "New" in the toolbar and in the "Class Name" panel browse
//    to "FileExample.class".
//
// 3) Press "Class" in the toolbar to open the "Class Test Parameters".
//
// 4) Specify a User Defined Test Case:
//    4.1) Open "Dynamic Analysis" -> "Test Case Generation" -> "User
//         Defined" -> "Method Inputs" -> "analyze".
//    4.2) Right click on "java.io.File ARG1" and select "Add Input Value".
//    4.3) Enter "new java.io.File ("ABC")" in the box.
//
// 5) Specify the stubs to use for the User Defined Test Cases.
//    5.1) Open "Test Case Execution".
//    5.2) Unselect "Execute Automatic".
//    5.3) Open "Stubs"
//    5.4) Open "Options for User Defined Test Cases" and verify that
//         "Use User Defined Stubs" is selected.
//
// 6) Note that "FileExampleStubs" will be used as the $DEFAULT Stubs Class
//    for the test.
//    6.1) Right click on "Stubs Class: $DEFAULT" and select "Locate 
//         Stubs Class .class file".
//    6.2) Close the dialog showing the location of the .class file.
//
// 7) Close the "Class Test Parameters" window and start the test by
//    pushing "Start" in the toolbar.
//
// 8) Once the testing is done push "View" in the toolbar to see the test
//    cases run.
//    8.1) Open "User Defined Test Cases" -> "Method Inputs" -> "analyze"
//         -> "Test Case 1"
//    8.2) Note the "Test Case Input" and "Outcomes".  
//         The Stubs used are shown with the little black squares.
//
// "FileExample.ctp" contains the parameters as set in the above steps.
//
//
// Changing Stubs Options:
// ----------------------
//
// The stubs to use when testing a class can be very easily changed.
// For example to run the automatic Test Cases with the user defined
// Stubs and the user defined Test Cases without stubs do the follwing:
//
// 1) Load "FileExample.ctp" in the "Class Testing UI".
//
// 2) Push "Class" in the toolbar. In the "Class Test Parameters" window:
//    2.1) Open "Dynamic Analysis" -> "Test Case Execution".
//         Make sure "Execute Automatic" is unselected and "Execute User 
//         Defined" is selected.
//    2.2) Open "Stubs" to select what stubs to use.
//         2.2.1) Under "Options for Automatic Test Cases", select "Use
//                Automatic Stubs" and unselect "Use User Defined Stubs".
//         2.2.2) Under "Options for User Defined Test Cases", unselect
//                "Use User Defined Stubs".
//
// 3) Close the "Class Test Parameters" window and push "Start" to test 
//    the class.
//
// 4) Once the test is complete push "View" in the toolbar to see the 
//    test cases run.
//    Open the branches in the "View Test Cases" window. Note that the
//    User Defined Stubs have been used for the "Automatic Test Cases"
//    and no stubs have been used for the "User Defined Test Cases".
//
   
package examples.dynamic.stubs.userdef;

import java.io.*;

public class FileExample
{
    public static String analyze (File file)
    {
        StringBuffer tmp = new StringBuffer ();
        tmp.append (file.getAbsolutePath ());
        tmp.append (':');
        tmp.append (file.setLastModified (100L));
        tmp.append (':');
        tmp.append (file.compareTo (new File ("X001.txt")));
        tmp.append (':');
        tmp.append (file.compareTo (new File ("XXX")));
        tmp.append (':');
        return tmp.toString ();
    }
}
