//
// Stubs for testing FileExample class.
//

package examples.dynamic.stubs.userdef;

import java.lang.reflect.*;
import java.io.*;

class FileExampleStubs extends jtest.Stubs
{
    // this method will be called whenever a method in the "FileExample" class
    // invokes a method external to the class

    public static Object stubs (Method method, Object _this, Object[] args)
    {
        String method_name = method.getName ();

        if (method_name.equals ("getAbsolutePath"))
            return "Z:\\tmp\\X001.txt";

        if (method_name.equals ("setLastModified")) {
            // primitive "args" are wrapped in an Object, unwrap "time"
            long time = ((Long) args [0]).longValue ();

            if (time < 0) {
                // note that one can specify an exception to be thrown
                // in the stub
                throw new IllegalArgumentException ("time is: " + time); 
            }

            return new Boolean (true);  // wrap primitive return type
        }

        if (method_name.equals ("compareTo")) {
            File file = (File) args [0];
            if (file.getName ().equals ("X001.txt"))
                return new Integer (10);
            return new Integer (0);
        }

        return NO_STUB_GENERATED;
    }
}
