//
// Test Class for Interpreter class.
//
// See "Interpreter.ctp".
//

package examples.dynamic.stubs.userdef;

import java.io.*;
import java.lang.reflect.*;

class InterpreterTest extends jtest.TestClass
{
    public static void testAdd34 ()
    {
        // create a generic InputStream
        InputStream stream = (InputStream) makeStubObject (InputStream.class);
        Interpreter itp = new Interpreter (stream);
        try {
            int value = itp.getNext ().intValue ();
            assert ("3 + 4 == 7", value == 7);
        } catch (IOException e) {
            assertFailed (e.toString ());
        }
    }


    // Stubs to be used when executing "testAdd34"

    public static Object stubsAdd34 (Method method)
    {
        String method_name = method.getName ();

        if (method_name.equals ("readUTF"))
            return "ADD";
        if (method_name.equals ("readInt")) {
            switch (_num_readInt++) {
            case 0:  return new Integer (3);
            default: return new Integer (4);
            }
        }

        return NO_STUB_GENERATED;
    }
    private static int _num_readInt = 0;
}
