// This example shows how to use "Test Classes" to write explicit test
// cases to test a class.
//
// The class CounterTest specifies three test classes for this class.
//
// To test this class with the CounterTest class:
//
// 1) Bring up the Jtest "Class Testing UI"
//
// 2) Browse to "Counter.class".
//
// 3) Add "CounterTest" in the "Class Test Parameters":
//    3.1) Push the "Class" button in the toolbar.
//    3.2) Open "Dynamic Analysis" -> "Test Case Generation" ->
//         "User Defined".
//    3.3) Select "Add Test Class" from the popup menu of the
//         "Test Classes" node.
//    3.4) Enter "examples.dynamic.testclasses.CounterTest".
//    3.5) Close the "Class Test Parameters" window.
//
// 4) Push the "Start" button in the toolbar.
//
// 5) Note that Jtest finds an "Uncaught Runtime Exception" from the 
//    automatic test cases and one "Specification Error" from the
//    "testSubstract" user-defined test case in "CounterTest".


package examples.dynamic.testclasses;

public class Counter
{
    public void add (int i) {
        _value += i;
    }
    public void substract (int i) {
        _value += i;  // BUG: should be "-="
    }
    public void divide (int i) {
        _value /= i;
    }

    public final int getValue () {
        return _value;
    }

    private int _value;
}
