// Test Class for class Counter. 
//
// This class contains 3 test cases that Jtest will run as part
// of the dynamic analysis.
//
// The "assert" method is defined in "jtest.TestClass"


package examples.dynamic.testclasses;

import jtest.*;

public class CounterTest extends TestClass
{
    public static void testAdd ()
    {
        Counter c = new Counter ();
        c.add (3);
        c.add (4);
        assert ("should be 7", c.getValue () == 7);
    }

    public static void testSubstract ()
    {
        Counter c = new Counter ();
        c.substract (3);
        c.substract (4);
        assert ("should be -7", c.getValue () == -7);
    }

    public static void testDivideThrowsArithmeticException ()
    {
        boolean exception_thrown = false;
        Counter c = new Counter ();
        c.add (10);

        try {
            c.divide (0);
        } catch (ArithmeticException ae) {
            exception_thrown = true;
        }

        assert ("should throw ArithmeticException", exception_thrown);
    }
}
