package examples.dynamic.whitebox;

public class ArrayFixed
{
    public ArrayFixed () {
        _array = new Object [10];
    }

    public void put (Object object, int index)
    {
        if (index < 0)
            throw new IllegalArgumentException ("index is negative: " + index);

        if (index >= _array.length) {
            // expand the array

            Object[] old_array = _array;
            _array = new Object [index+1];
            System.arraycopy (old_array, 0, _array, 0, old_array.length);
        }

        _array [index] = object;
    }

    // Note, here the method self-documents that it throws an
    // ArrayIndexOutOfException. Another possible method implementation 
    // would be for it to return null for indexes that have not been
    // assigned any values

    public Object get (int index)
        throws ArrayIndexOutOfBoundsException
    {
        return _array [index];
    } 

    private Object _array [];
}
