// This example shows how jtest does testing when instance variables
// are involved. I.e. when the exception happening depends on an
// instance variable that is set by some other method that the one
// currently being tested.
//
// Note that for jtest to find the NegativeArraySizeException in
// 'allocateArray' we have to tell jtest to try calling sequences of
// length > 1. 
//
// See: "Class" -> "Dynamic Analysis" -> "Test Case Generation"
//      -> "Automatic" -> "Test calling sequences up to length".


package examples.dynamic.whitebox;

public class InstVars
{
    InstVars () {
        _size = 100;
    }

    public int[] allocateArray () {
        // the possible NegativeArraySizeException here will depend on
        // the value of the instance variable '_size'
        return new int [_size];
    }

    public void setSize (int size) {
        _size = size;
    }

    private int _size;
}
