// This example shows how Jtest checks the state of the "this" object
// after a method as been invoked on it.
//
// The state of the "this" object is shown in the "Outcomes" for the
// method. Sometimes Jtest will not show the state because there
// are no methods defined in the Object's class that allow to show
// the state. To make sure Jtest can show the state define a
// "String toString ()" method for the class. Jtest will use the 
// return value from "toString ()" to show the object's  state.
//
// 1) Test this class using the "Class Testing UI".
//
// 2) Push the "View" button to see the test cases generated.
//
// 3) Open "Automatic Test Cases" -> "setState" -> "Test Case 2".
//    Notice how jtest uses "toString()" to represent the instance
//    state.


package examples.dynamic.whitebox;

public class InstanceState
{
    public void setState (int state) {
        _state = state;
    } 

    public String toString () {
        return "InstanceState[" + _state + "]";
    }

    private int _state;
}
