// Long Calling Sequences:
//
// If this class is tested by just trying calling sequences of lenght 1
// no errors are found. Errors can only happen if one tries calling 
// sequences longer than 1.
//
// By default jtest tries all calling sequences of length 1. For more
// throught testing one can tell jtest to try all calling sequences
// of length 2. 
//
// We are going to run jtest on this class and tell it to try calling
// sequences of length 2:
//
// 1) Start jtest.
// 2) Open the "LCS.ctp" test in this directory.
// 3) Tell jtest to try calling sequences of length 2
//    3.1) Push "Class" in the toolbar.
//    3.2) Open "Dynamic Analysis" -> "Test Case Generation" -> "Automatic"
//    3.3) Use the popup menu to set "Test calling sequences up to length"
//         to 2. (if not already set to 2).
// 4) Push "Start" in the toolbar, wait for the test to finish.
// 5) Look at the errors found by jtest. You will see that the
//    "Test Case Input" that gives the errors needs at least calling
//    two of the methods in the class.


package examples.dynamic.whitebox;

import java.util.*;

public class LCS {
    public void addElement (Object obj) {
        _vector.addElement (obj);
    }

    public void processAll () {
        Enumeration e = _vector.elements ();
        while (e.hasMoreElements ())
            ((LCS) e.nextElement ()).process ();
    }

    private void process () {
        System.out.println ("processing: " + this);
    }

    private Vector _vector = new Vector ();
}
