// Example of class for which jtest cannot generate test cases:
//
// For this class jtest cannot generate any test cases to test
// the "allocate" method.
// In order to generate a test-case, jtest needs to first generate
// an Object of type "NoTestCases". This is not possible because
// there is no constructor that can be called that will generate
// a valid object, the only constructor throws an exception instead.
//
// In general it may be possible to generate a valid object, but
// jtest could be unable to find the right constructor or constructor
// parameters. In this is the case, the solution is to tell jtest
// what object to use using either:
//
// 1) "Class Test Parameters" -> "Dynamic Analysis" -> "Test Case Generation"
//    -> "Automatic" -> "Restricted Inputs" -> "THIS object".
//
// or 
// 
// 2) Add an special constructor to the class that generates the desired
//    object (see the "Constructor.java" example).


package examples.dynamic.whitebox;

public class NoTestCases
{
    NoTestCases () {
        throw new RuntimeException ();
    }

    public int[] allocate (int size) {
        return new int [size];
    }
}
