// Supress example: Exceptions In Throws Clause


package examples.dynamic.whitebox;

public class Suppress0
{
    public static void method (int size)
        throws NegativeArraySizeException
    {
        // If the "Exceptions In Throws Clause" suppression cathegory is on
        // jtest will not report the NegativeArraySizeException that can
        // occur when calling this method with a negative 'size'.
        //
        // The exception being listed in the throws clause means that the
        // developer was aware of that possibility and that the correct
        // behavior of the method is to throw that exception if 'size' is
        // negative.

        int[] array = new int [size]; 
        array [2] = 0;
    }
}
