// Supress example: Explicitly Thrown Exceptions


package examples.dynamic.whitebox;

public class Suppress2
{
    public static void method (int index)
    {
        // If the "Explicity Thrown Exceptions" suppression cathegory is on
        // jtest will not report the InvalidIndexException that can
        // occur when calling this method with 'index' greater or equal
        // than 10.
        //
        // The exception is explicitly thrown by the written code. This
        // means that throwing that exception is a correct behavior for
        // the method.

        if (index >= 10)
            throw new InvalidIndexException ("index = " + index);
    }

    private int[] _storage = new int [10];
}

class InvalidIndexException extends RuntimeException {
    InvalidIndexException () {super ();}
    InvalidIndexException (String message) {super (message);}
}
