/*
 * $RCSfile: Command_fixed.java,v $
 * $Revision: 32.1 $
 *
 * Comments:
 *
 * (C) Copyright ParaSoft Corporation 1998.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 *
 * $Author: roman $          $Locker:  $
 * $Date: 1999/07/21 15:35:20 $
 */

// a Command defines an action that returns a status

public abstract class Command implements Runnable
{
    // classes extending Command should override this method
    public abstract boolean action ();

    // executes command within a timeout, returns true if it succeeds 
    public static boolean execute (Command command, long timeout) {
        if (command == null)
            return false;

        Thread thread = new Thread (command); 
        thread.start ();

        try {
            thread.join (timeout);
        } catch (InterruptedException ie) {
            return false;
        }

        if (thread.isAlive ()) {
            thread.stop ();
            return false;
        }

        return command.getStatus ();
    }

    public final void run () {
        _status = action ();
    }
    boolean getStatus () {return _status;}
    private boolean _status;
}
