
// Array: this class represents an expandable array, the arrays expands
//        automatically to accept any positive index.
//
// The uncaught runtime exceptions found by Jtest in this program point to
// a bug in the program.


package examples.eval.project;

public class Array
{
    public Array () {
        _array = new Object [10];
    }

    public void put (Object object, int index)
    {
        expandIfNeeded (index);
        // the ArrayIndexOutOfBoundsException reported by Jtest for the next
        // line is due to the crash-causing error in 'expandIfNeeded ()'.
        _array [index] = object;
    }

    private void expandIfNeeded (int index)
    {
        // the following statement contains a crash-causing error, the correct
        // code should be "index >= _array.length"

        if (index > _array.length) {
            // expand the array

            Object[] old_array = _array;
            _array = new Object [index+1];
            System.arraycopy (old_array, 0, _array, 0, old_array.length);
        }
    }

    public Object get (int index)
    {
        expandIfNeeded (index);
        return _array [index];
    } 

    private Object _array [];
}
