// This class contains the simplest methods that show the most common
// errors Jtest finds during Dynamic Analysis. Each method contains a
// description of the error, as well as how the uncaught runtime
// exception happens.


package examples.eval.project;

public class Dynamic
{
    public static void outOfBoundsEx (int index)
    {
        // If 'index' is greater than or equal to five, ArrayIndexOut-
        // OfBoundsException will occur when this method is called

        int [] array = new int [5];

        array [index] = 10;
    }

    public static void classCastEx (Object o)
    {
        // If this method is called with 'o' as Object type
        // instead of String type...a ClassCastException

        System.out.println ((String) o);
    }        

    public static void negativeArraySizeEx (int arraySize)
    {
        // The argument 'arraySize' can possibly be negative.
        // Instantiating array will cause NegativeArraySizeException

        Object [] array = new Object [arraySize];

        System.out.println ("array.length = " + array.length);
    }

    public static void numberFormatEx (String string)
    {
        // When Array 'args [0]' is "#$%" (charatcer) value this
        // will cause a NumberFormatException when this method
        // is called

        System.out.println (Integer.parseInt (string));
    }

    public static void stringIndexEx (int index)
    {
        // When 'index' is outside the boundaries of the string
        // it is referencing, a StringIndexOutOfBoundsException
        // is caused

        String hello = "Hello!";

        System.out.println (hello.charAt (index));
    }


    Dynamic (Object o) {
        _o = o;
    }

    private Object _o = null;

    public static void nullPointerEx (Dynamic d)
    {
        // The constructor for Dynamic should have checked that
        // all its members are initialized properly.
        // 
        // This method incorrectly assumes a valid d. When this
        // method is called with an invalid d it causes a Null-
        // pointerException

        System.out.println (d._o.toString ());
    }
}
