import java.io.*;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class JtestTask extends Task
{
    private String msg;
    private String _ctp = "";
    private String _class_name = "";
    private String _classpath = "";
    private String _reportfile = "";

    // The method executing the task
    public void execute() throws BuildException {
        exec ();
    }

    public void exec () {    
        String cmdArray [] = new String [8];	
     
        cmdArray [0] = "jtestgui";
        cmdArray [1] = "-ctp_new";
        cmdArray [2] = _ctp;
        cmdArray [3] = "-class_name";
        cmdArray [4] = _class_name;
        cmdArray [5] = "-nogui";
        cmdArray [6] = "-report_ascii";
        cmdArray [7] = _reportfile;
     
        /*
        for (int i = 0; i < cmdArray.length; i++)
            System.out.print (cmdArray [i] + " ");
        System.out.println ();
        */
     
        try {
            Process process = Runtime.getRuntime ().exec (cmdArray);
            showProcessOutput (process);
            process.waitFor ();
        } catch (Exception e) {
            e.printStackTrace ();
        }
    }
   
    public void setCtp (String ctp) {
        _ctp = ctp;
    }
   
    public void setClassname (String class_name) {
        _class_name = class_name;
    }
   
    public void setClasspath (String classpath) {
        _classpath = classpath;
    }
   
    public void setReportfile (String reportfile) {
        _reportfile = reportfile;
    }
   
    public static void main (String args[]) {
        /* this is not necessary, but it is used for testing */
        JtestTask t = new JtestTask (); 
        t.setClassname ("Simple" );
        t.setReportfile ("jtest_report.txt");
        t.setCtp ("Simple.ctp");
        t.exec ();
    }
    
    private static void showProcessOutput (Process process)
    {
        PrintOutThread tos = new PrintOutThread (process.getInputStream ());
        PrintOutThread tes = new PrintOutThread (process.getErrorStream ());

        tos.start ();
        tes.start ();

        try {
            tos.join ();
            tes.join ();
        } catch (InterruptedException ie) {
            ie.printStackTrace ();
        }
    }

    private static class PrintOutThread extends Thread
    { 
        public PrintOutThread (InputStream stream) {
            _stream = stream;
            setDaemon (true);
        }

        public void run () {
            int c;
            try {
                while ((c = _stream.read ()) != -1)
                    System.out.write (c);
            } catch (IOException e) {
            }
        }

        private InputStream _stream;
    }
}
